#ifndef __INCLUDE_JM_FONT_FNTFILE_H
#define __INCLUDE_JM_FONT_FNTFILE_H

struct JM_FONT_FNT_FILE_T __attribute__((packed))
{
	int sig         // "FNT\0"
	int size        // sizeof(JM_FONT_FNT_FILE_T) - 8
	int fonttype    // 0 = fixed bitmap, 1 = var-bitmap
	short char1     // 0
	short charn     // 256
	short maxw      // max glyph bitmap width
	short maxh      // max glyph bitmap height
	short cax       // stanard glyph advance width
	short cay       // stanard glyph advance height
	short cbx       // stanard glyph bearing left
	short cby       // stanard glyph bearing top
	int reserved    // reserved must be 0
}:

struct JM_FONT_FNT_CHAR_T __attribute__((packed))
{
	int sig             // "CHR\0"
	int size            // sizeof(JM_FONT_FNT_CHAR_T) - 8
	char c0             // ascii character
	char c1             // '\0'
	char c2							// '\0'
	char c3							// '\0'
	short cgx           // glyph width
	short cgy           // glyph height
	short cax           // glyph advance width
	short cay           // glyph advance height
	short cbx           // glyph bearing left
	short cby           // glyph bearing top
  int doffset         // offset from start of file to glyph data
	int reserved        // reserved
};

struct JM_FONT_FNT_GLYPH_T __attribute__((packed))
{
	int sig             // "GLY\0"
	int size            // length of pixel data
	char pixeldata[]    // pixel data 1 byte/pixel
};

#endif
