''  jm_font_mygl_fixed_bm.bas - jm_font
''	Copyright (C) 2005-2006 Jeff Marshall (coder@execulink.com)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.

Type JM_FONT_CHAR_T field = 1
	handle as integer     '' extra handle (or memory pointer to glyph pixel data)
End Type
#define JM_FONT_CHAR_T_DEFINED

#include "inc1/jm_font_rt.bi"
#include "jm_font.bi"
#include "mygl.bi"
#include "ploadlib.bi"

#define mBLEND &hff000000

' =================
' Fixed BMP Methods
' =================

private Sub fonti_Delete alias "fonti_Delete" (byval fnt As JM_FONT_PTR)
	Dim i as Integer
	If (fnt) Then
		for i = 0 to 255	
			mygl_texture_unload( Cast(myglTexture, fnt->chardata[i].handle) )
		next i
		if (fnt->tmpch)     then ImageDestroy fnt->tmpch
		if (fnt->glyphdata) then deallocate   fnt->glyphdata
		if (fnt->chardata)  then deallocate   fnt->chardata
	End If
End Sub

private Function fonti_GetCharAdvanceX alias "fonti_GetCharAdvanceX" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	if (fnt) then
		function = fnt->w
	end if
End Function

private Function fonti_GetCharAdvanceY alias "fonti_GetCharAdvanceY" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	if (fnt) then
		function = fnt->h
	end if
End Function

Function fonti_DrawChar alias "fonti_DrawChar" (byval fnt As JM_FONT_PTR, ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal foreColor as Integer, ByVal backColor as Integer, ByVal trans as integer) as integer
	Dim prevTinting as integer
	function = 0
	If (fnt) Then
		mygl_texture_blit ( Cast(myglTexture, fnt->chardata[ch and 255].handle), x, y, MYGL_BLIT_BLEND, forecolor or mBLEND)
		function = fnt->w
	End If
End function

' =================
' Font Creation
' =================

Function FONT_CreateFromImage alias "FONT_CreateFromImage" (ByVal w As Integer, ByVal h As Integer, ByVal img as Any Ptr) As JM_FONT_PTR
	Dim as Integer i, j, sx, sy
	Dim tmp as Any Ptr, c as integer ptr
	Dim fnt As JM_FONT_PTR
	Dim t As Any Ptr = ImageCreate(w, h, 0)
	fnt = Allocate(sizeof(JM_FONT_T))
	fnt->typ = JM_FONT_TYPE_BITMAP
	fnt->w = w
	fnt->h = h
	fnt->bpchar = sizeof(JM_FONT_CHAR_T)
	fnt->chardata = Callocate(256 * fnt->bpchar)
	fnt->bpglyph = 0
	fnt->glyphdata = 0
	fnt->tmpch = 0
	For i = 0 to 255
		sx = (i Mod 16) * w
		sy = (i  \  16) * h
		Get img, (sx, sy)-(sx + w-1,sy + h-1), t
		c = t
		for j = 1 to w*h
			if (c[j] and &hffffff) then c[j] OR= &HFFFFFFFF
		next j				
		MyGL_Texture_LoadMem Cast(byte ptr, t) + 4, Cast(myglTexture, fnt->chardata[i].handle), w, h, MYGL_PIXEL_RGBA, 1, 0, MYGL_TEXTURE_LINEAR
	Next i
	ImageDestroy t
	Return fnt
End Function

Function FONT_CreateFromBMP alias "FONT_CreateFromBMP" (ByVal w As Integer, ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
	Dim tmp As Any Ptr, fnt As JM_FONT_PTR = 0
	tmp = ImageCreate(w * 16, h * 16)
	if (tmp) Then
		if Bload(*strFile, tmp) = 0 then
			fnt = FONT_CreateFromImage(w, h, tmp)
		end if
		ImageDestroy tmp
	End If
	fnt->Delete = @fonti_Delete
	fnt->GetCharAdvanceX = @fonti_GetCharAdvanceX
	fnt->GetCharAdvanceY = @fonti_GetCharAdvanceY
	fnt->DrawChar = @fonti_DrawChar
	return fnt
End Function

Function FONT_CreateFromPNG alias "FONT_CreateFromPNG" (ByVal w As Integer, ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
	Dim tmp As Any Ptr, fnt As JM_FONT_PTR = 0
	''tmp = ImageCreate(w * 16, h * 16)
	''if (tmp) Then
		tmp = PLoad(strFile, 32)
		if (tmp) Then
		''if Pload(*strFile, tmp) = 0 then
			fnt = FONT_CreateFromImage(w, h, tmp)
		end if
		ImageDestroy tmp
	''End If
	fnt->Delete = @fonti_Delete
	fnt->GetCharAdvanceX = @fonti_GetCharAdvanceX
	fnt->GetCharAdvanceY = @fonti_GetCharAdvanceY
	fnt->DrawChar = @fonti_DrawChar
	return fnt
End Function
